#!/usr/bin/perl

$map[0][0][0];

$halfway = 108;
$maxheight = 40; 
$variation = 16;

my $c1 = rand($maxheight) + $halfway; #Z for X,Y
my $c2 = rand($maxheight) + $halfway; #Z for X,MY
my $c3 = rand($maxheight) + $halfway; #Z for MX,Y
my $c4 = rand($maxheight) + $halfway; #Z for MX,MY

$map [1][1] = $c1;
$map [1][256] = $c2;
$map [256][1] = $c3;
$map [256][256] = $c4;

$map[1][1][$c1] = "01";
$map[1][256][$c2] = "01";
$map[256][1][$c3] = "01";
$map[256][256][$c4] = "01";

&MapMaker(0,0,256,256);


sub MapMaker
{
	my $x = @_[0];
	my $y = @_[1];
	my $mx = @_[2];
	my $my = @_[3];
	
	my $hx = $mx / 2;
	my $hy = $my / 2;
	
	
	$map[$hx][$y] = ($map[$x][$y] + $map[$mx][$y]) / 2;
	$map[$x][$hy] = ($map[$x][$y] + $map[$x][$my]) / 2;
	$map[$hx][$my] = ($map[$x][$my] + $map[$mx][$my]) / 2;
	$map[$mx][$hy] = ($map[$mx][$y] + $map[$mx][$my]) / 2;
	$map[$hx][$hy] = ($map[$x][$y] + $map[$mx][$y] + $map[$x][$my] +$map[$mx][$my]) / 4;
		
	my $z1 = rand($variation) + ($map[$hx][$y] - 8); #Z for X,Y
	my $z2 = rand($variation) + ($map[$x][$hy] - 8); #Z for X,MY
	my $z3 = rand($variation) + ($map[$hx][$my] - 8); #Z for MX,Y
	my $z4 = rand($variation) + ($map[$mx][$hy] - 8); #Z for MX,MY
	my $z5 = rand($variation) + ($map[$hx][$hy] - 8); #Z for MX,MY
	
	$map[$hx][$y][$z1] = "01";
	$map[$x][$hy][$z2] = "01";
	$map[$hx][$my][$z3] = "01";
	$map[$mx][$hy][$z4] = "01";
	$map[$hx][$hy][$z5] = "01";
	
	if ($hx > 2)
	{
		&MapMaker($x,$y,$hx,$hy);
		&MapMaker($hx,$y,$mx,$hy);
		&MapMaker($x,$hy,$hx,$my);
		&MapMaker($hx,$hy,$mx,$my);
	}
}

